Tasse_Avant = {};

function Tasse_Avant.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Attachable, specializations);
end;
function Tasse_Avant:load(xmlFile)
	local rotationNodePartDents = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartDents#index"));
    if rotationNodePartDents ~= nil then
        self.rotationPartDents = {};
        self.rotationPartDents.node = rotationNodePartDents;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartDents#minRot"));
        self.rotationPartDents.minRot = {};
        self.rotationPartDents.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartDents.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartDents.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartDents#maxRot"));
        self.rotationPartDents.maxRot = {};
        self.rotationPartDents.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartDents.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartDents.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartDents.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartDents#rotTime"), 2)*1000;
        self.rotationPartDents.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartDents#touchRotLimit"), 10));
    end;  

	local rotationNodePartVerrain = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartVerrain#index"));
    if rotationNodePartVerrain ~= nil then
        self.rotationPartVerrain = {};
        self.rotationPartVerrain.node = rotationNodePartVerrain;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartVerrain#minRot"));
        self.rotationPartVerrain.minRot = {};
        self.rotationPartVerrain.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartVerrain.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartVerrain.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartVerrain#maxRot"));
        self.rotationPartVerrain.maxRot = {};
        self.rotationPartVerrain.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartVerrain.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartVerrain.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartVerrain.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartVerrain#rotTime"), 2)*1000;
        self.rotationPartVerrain.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartVerrain#touchRotLimit"), 10));
    end;   
	local translationNodeVerrain = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationVerrain#index"));
    if translationNodeVerrain ~= nil then
        self.translationVerrain = {};
        self.translationVerrain.node = translationNodeVerrain;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationVerrain#minTrans"));
        self.translationVerrain.minTrans = {};
        self.translationVerrain.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationVerrain.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationVerrain.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationVerrain#maxTrans"));
        self.translationVerrain.maxTrans = {};
        self.translationVerrain.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationVerrain.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationVerrain.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationVerrain.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationVerrain#transTime"), 2)*1000;
        self.translationVerrain.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationVerrain#touchTransLimit"), 10);
    end; 
	self.rotationMaxDents = false;
	self.rotationMaxVerrain = false;
	self.translationMaxVerrain = false;
end;
function Tasse_Avant:delete()
end;
function Tasse_Avant:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Tasse_Avant:keyEvent(unicode, sym, modifier, isDown)
	if isDown and sym == Input.KEY_n then
		self.rotationMaxDents = not self.rotationMaxDents;
		self.rotationMaxVerrain = not self.rotationMaxVerrain;
		self.translationMaxVerrain = not self.translationMaxVerrain;
	end;
end;

function Tasse_Avant:update(dt)
	if self.rotationPartDents ~= nil then
        local x, y, z = getRotation(self.rotationPartDents.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartDents.maxRot, self.rotationPartDents.minRot, 3, self.rotationPartDents.rotTime, dt, not self.rotationMaxDents);
        setRotation(self.rotationPartDents.node, unpack(newRot));
    end;   
	if self.rotationPartVerrain ~= nil then
        local x, y, z = getRotation(self.rotationPartVerrain.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartVerrain.maxRot, self.rotationPartVerrain.minRot, 3, self.rotationPartVerrain.rotTime, dt, not self.rotationMaxVerrain);
        setRotation(self.rotationPartVerrain.node, unpack(newRot));
    end;	
	if self.translationVerrain ~= nil then 
		local x, y, z = getTranslation(self.translationVerrain.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationVerrain.maxTrans, self.translationVerrain.minTrans, 3, self.translationVerrain.transTime, dt, not self.translationMaxVerrain); 
		setTranslation(self.translationVerrain.node, unpack(newTrans)); 
	end;
end;


function Tasse_Avant:draw()
	if self.rotationMaxDents then
		g_currentMission:addExtraPrintText("Touche N : Postion de route");		
	else
		g_currentMission:addExtraPrintText("Touche N : Postion de travail");
	end;
end;