--
-- seeding01
-- Class for all seeding01s
--
-- @author  Stefan Geiger (mailto:sgeiger@giants.ch)
-- @modified Mev01
-- @date  20/09/08

seeding01 = {};

function seeding01.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(SowingMachine, specializations);
end;

function seeding01:load(xmlFile)

    local rotationPartNodeRight = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartRight#index"));
    if rotationPartNodeRight ~= nil then
        self.rotationPartRight = {};
        self.rotationPartRight.node = rotationPartNodeRight;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartRight#minRot"));
        self.rotationPartRight.minRot = {};
        self.rotationPartRight.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartRight.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartRight.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartRight#maxRot"));
        self.rotationPartRight.maxRot = {};
        self.rotationPartRight.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartRight.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartRight.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartRight.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartRight#rotTime"), 2)*1000;
        self.rotationPartRight.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartRight#touchRotLimit"), 10));
    end;

    local rotationPartNodeLeft = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartLeft#index"));
    if rotationPartNodeLeft ~= nil then
        self.rotationPartLeft = {};
        self.rotationPartLeft.node = rotationPartNodeLeft;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartLeft#minRot"));
        self.rotationPartLeft.minRot = {};
        self.rotationPartLeft.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartLeft.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartLeft.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartLeft#maxRot"));
        self.rotationPartLeft.maxRot = {};
        self.rotationPartLeft.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartLeft.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartLeft.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartLeft.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartLeft#rotTime"), 2)*1000;
        self.rotationPartLeft.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartLeft#touchRotLimit"), 10));
    end;
 
    local rotationPartNodeRight2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartRight2#index"));
    if rotationPartNodeRight2 ~= nil then
        self.rotationPartRight2 = {};
        self.rotationPartRight2.node = rotationPartNodeRight2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartRight2#minRot"));
        self.rotationPartRight2.minRot = {};
        self.rotationPartRight2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartRight2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartRight2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartRight2#maxRot"));
        self.rotationPartRight2.maxRot = {};
        self.rotationPartRight2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartRight2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartRight2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartRight2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartRight2#rotTime"), 2)*1000;
        self.rotationPartRight2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartRight2#touchRotLimit"), 10));
    end;

    local rotationPartNodeLeft2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartLeft2#index"));
    if rotationPartNodeLeft2 ~= nil then
        self.rotationPartLeft2 = {};
        self.rotationPartLeft2.node = rotationPartNodeLeft2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartLeft2#minRot"));
        self.rotationPartLeft2.minRot = {};
        self.rotationPartLeft2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartLeft2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartLeft2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartLeft2#maxRot"));
        self.rotationPartLeft2.maxRot = {};
        self.rotationPartLeft2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartLeft2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartLeft2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartLeft2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartLeft2#rotTime"), 2)*1000;
        self.rotationPartLeft2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartLeft2#touchRotLimit"), 10));
    end;

    local rotationPartNodeRight3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartRight3#index"));
    if rotationPartNodeRight3 ~= nil then
        self.rotationPartRight3 = {};
        self.rotationPartRight3.node = rotationPartNodeRight3;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartRight3#minRot"));
        self.rotationPartRight3.minRot = {};
        self.rotationPartRight3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartRight3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartRight3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartRight3#maxRot"));
        self.rotationPartRight3.maxRot = {};
        self.rotationPartRight3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartRight3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartRight3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartRight3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartRight3#rotTime"), 2)*1000;
        self.rotationPartRight3.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartRight3#touchRotLimit"), 10));
    end;

    local rotationPartNodeLeft3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartLeft3#index"));
    if rotationPartNodeLeft3 ~= nil then
        self.rotationPartLeft3 = {};
        self.rotationPartLeft3.node = rotationPartNodeLeft3;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartLeft3#minRot"));
        self.rotationPartLeft3.minRot = {};
        self.rotationPartLeft3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartLeft3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartLeft3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartLeft3#maxRot"));
        self.rotationPartLeft3.maxRot = {};
        self.rotationPartLeft3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartLeft3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartLeft3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartLeft3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartLeft3#rotTime"), 2)*1000;
        self.rotationPartLeft3.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartLeft3#touchRotLimit"), 10));
    end;

 
    self.hasGroundContact = true;
    self.isExpandedRight = false;
    self.isExpandedLeft = false;
    self.isExpandedRight2 = false;
    self.isExpandedLeft2 = false;
    self.isExpandedRight3 = false;
    self.isExpandedLeft3 = false;
	self.isExpandedBack = false;
    self.rotationMaxRight = true;
    self.rotationMaxLeft = true;
    self.rotationMaxRight2 = true;
    self.rotationMaxLeft2 = true;
    self.rotationMaxRight3 = true;
    self.rotationMaxLeft3 = true;

end;

function seeding01:delete()
end;

function seeding01:mouseEvent(posX, posY, isDown, isUp, button)
end;

function seeding01:keyEvent(unicode, sym, modifier, isDown)
     
	 if isDown and sym == Input.KEY_n then
		self.rotationMaxRight = not self.rotationMaxRight;
            self.rotationMaxLeft = not self.rotationMaxLeft;
		self.rotationMaxRight2 = not self.rotationMaxRight2;
            self.rotationMaxLeft2 = not self.rotationMaxLeft2;
		self.rotationMaxRight3 = not self.rotationMaxRight3;
            self.rotationMaxLeft3 = not self.rotationMaxLeft3;
			self.rotationMaxBack = not self.rotationMaxBack;
		
			end;
end;	

function seeding01:update(dt)
    
    if self.isAttached then
        self.isExpandedRight = false;
        if self.rotationPartRight ~= nil then
            local x, y, z = getRotation(self.rotationPartRight.node);
            local minRot = self.rotationPartRight.minRot;
            local eps = self.rotationPartRight.touchRotLimit;

            if math.abs(x-minRot[1]) < eps and math.abs(y-minRot[2]) < eps and math.abs(z-minRot[3]) < eps then
                self.isExpandedRight = true;
            end;
        end;

        self.isExpandedLeft = false;
        if self.rotationPartLeft ~= nil then
            local x, y, z = getRotation(self.rotationPartLeft.node);
            local minRot = self.rotationPartLeft.minRot;
            local eps = self.rotationPartLeft.touchRotLimit;

            if math.abs(x-minRot[1]) < eps and math.abs(y-minRot[2]) < eps and math.abs(z-minRot[3]) < eps then
                self.isExpandedLeft = true;
            end;
        end;
		
        if self.rotationPartRight2 ~= nil then
            local x, y, z = getRotation(self.rotationPartRight2.node);
            local minRot = self.rotationPartRight2.minRot;
            local eps = self.rotationPartRight2.touchRotLimit;

            if math.abs(x-minRot[1]) < eps and math.abs(y-minRot[2]) < eps and math.abs(z-minRot[3]) < eps then
                self.isExpandedRight2 = true;
            end;
        end;

        self.isExpandedLeft2 = false;
        if self.rotationPartLeft2 ~= nil then
            local x, y, z = getRotation(self.rotationPartLeft2.node);
            local minRot = self.rotationPartLeft2.minRot;
            local eps = self.rotationPartLeft2.touchRotLimit;

            if math.abs(x-minRot[1]) < eps and math.abs(y-minRot[2]) < eps and math.abs(z-minRot[3]) < eps then
                self.isExpandedLeft2 = true;
            end;
        end;

        if self.rotationPartRight3 ~= nil then
            local x, y, z = getRotation(self.rotationPartRight3.node);
            local minRot = self.rotationPartRight3.minRot;
            local eps = self.rotationPartRight3.touchRotLimit;

            if math.abs(x-minRot[1]) < eps and math.abs(y-minRot[2]) < eps and math.abs(z-minRot[3]) < eps then
                self.isExpandedRight3 = true;
            end;
        end;

        self.isExpandedLeft3 = false;
        if self.rotationPartLeft3 ~= nil then
            local x, y, z = getRotation(self.rotationPartLeft3.node);
            local minRot = self.rotationPartLeft3.minRot;
            local eps = self.rotationPartLeft3.touchRotLimit;

            if math.abs(x-minRot[1]) < eps and math.abs(y-minRot[2]) < eps and math.abs(z-minRot[3]) < eps then
                self.isExpandedLeft3 = true;
            end;
        end;

    end;


    if self.rotationPartRight ~= nil then
        local x, y, z = getRotation(self.rotationPartRight.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartRight.maxRot, self.rotationPartRight.minRot, 3, self.rotationPartRight.rotTime, dt, not self.rotationMaxRight);
        setRotation(self.rotationPartRight.node, unpack(newRot));
    end;

    if self.rotationPartLeft ~= nil then
        local x, y, z = getRotation(self.rotationPartLeft.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartLeft.maxRot, self.rotationPartLeft.minRot, 3, self.rotationPartLeft.rotTime, dt, not self.rotationMaxLeft);
        setRotation(self.rotationPartLeft.node, unpack(newRot));
    end;
	
    if self.rotationPartRight2 ~= nil then
        local x, y, z = getRotation(self.rotationPartRight2.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartRight2.maxRot, self.rotationPartRight2.minRot, 3, self.rotationPartRight2.rotTime, dt, not self.rotationMaxRight2);
        setRotation(self.rotationPartRight2.node, unpack(newRot));
    end;

    if self.rotationPartLeft2 ~= nil then
        local x, y, z = getRotation(self.rotationPartLeft2.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartLeft2.maxRot, self.rotationPartLeft2.minRot, 3, self.rotationPartLeft2.rotTime, dt, not self.rotationMaxLeft2);
        setRotation(self.rotationPartLeft2.node, unpack(newRot));
    end;


    if self.rotationPartRight3 ~= nil then
        local x, y, z = getRotation(self.rotationPartRight3.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartRight3.maxRot, self.rotationPartRight3.minRot, 3, self.rotationPartRight3.rotTime, dt, not self.rotationMaxRight3);
        setRotation(self.rotationPartRight3.node, unpack(newRot));
    end;

    if self.rotationPartLeft3 ~= nil then
        local x, y, z = getRotation(self.rotationPartLeft3.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartLeft3.maxRot, self.rotationPartLeft3.minRot, 3, self.rotationPartLeft3.rotTime, dt, not self.rotationMaxLeft3);
        setRotation(self.rotationPartLeft3.node, unpack(newRot));
    end;


end;

function seeding01:draw()

     if self.attacherVehicle then
        g_currentMission:addExtraPrintText("Taste N : Smaschine klappen ");
	end;
   
end;

function seeding01:onAttach()
end;

function seeding01:onDetach()
end;